unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  EditBtn;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    CalcEdit1: TCalcEdit;
    Edit1: TEdit;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

function StrToBin(const S:String):qword;
var
  i: Integer;
begin
  Result:=0;
  for i:=1 to Length(S) do
  case s[i] of
    '1':Result:=Result*2+1;
    '0':Result:=Result*2;
    ' ':continue;
  else raise EFormatError.Create('Invalid binary in string');
  end;
end;

function BinToStr(w:qword):string;
var
  N: QWord;
begin
  if w=0 then begin Result:='0';exit;end;
  N:=w;
  Result:='';
  repeat
    if (N mod 2)=1 then Result:='1'+Result else Result:='0'+Result;
    N:=N div 2;
  until N=0;
end;

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin

end;

procedure TForm1.Button1Click(Sender: TObject);
var
  S: TCaption;
  N: QWord;
begin
  S:=Edit1.Text;
  N:=StrToBin(S);
  ShowMessage(IntToStr(N));
end;

procedure TForm1.Button2Click(Sender: TObject);
var
  N: Integer;
begin
  N:=CalcEdit1.AsInteger;
  ShowMessage(BinToStr(N));
end;

end.

